[data-type="radio"],
[data-type="checkbox"] {
  cursor: pointer;
  display: inline-flex;
  line-height: normal;
  min-height: 30px;
  position: relative;
  >input {
    &[type="radio"],
    &[type="checkbox"] {
      position: absolute;
      left: 7px;
      top: 10px;
      z-index: -1;
      opacity: 0;
      +.text {
        display: flex;
        justify-content: center;
        align-items: center;
        position: relative;
        top: 1px;
        &::before {
          top: 1px;
          content: "";
          background-color: #ffffff;
          cursor: pointer;
          display: inline-block;
          left: 0;
          margin-right: 3px;
          position: absolute;
        }
      }
      &[required] {
        +.text {
          &::before {
            border-color: $main-input-required-border-color;
            background-color: $main-input-required-bg-color;
          }
        }
      }
      &:disabled {
        +.text {
          &::before {
            color: $disabled-color;
            background-color: $disabled-bg-color;
            border-color: $disabled-border-color;
          }
        }
      }
    }
    &.error {
      &[type="radio"],
      &[type="checkbox"] {
        +.text {
          color: $main-input-fail-color;
          border-color: $main-input-fail-border-color;
          &::before {
            color: $main-input-fail-color;
            background-color: $main-input-fail-bg-color;
            border-color: $main-input-fail-border-color;
          }
        }
      }
    }
  }
  &.--check-list {
    margin: 0px;
    >input {
      &[type="radio"],
      &[type="checkbox"] {
        +.text {
          &::before {
            top: 0px;
            margin-right: 0px;
          }
        }
      }
    }
  }
}

[data-type="radio"] {
  >input {
    &[type="radio"] {
      +.text {
        padding-left: calc(#{$radio-size} + 10px);
        &::before {
          width: $radio-size;
          height: $radio-size;
          min-width: $radio-size;
          border: 1px solid $radio-border-color;
          @include border-radius($radio-radius);
        }
      }
      &:checked {
        +.text {
          &::after {
            content: "";
            top: 7px;
            left: 6px;
            width: 16px;
            height: 16px;
            position: absolute;
            background-color: $radio-check-color;
            @include border-radius(100%);
          }
        }
      }
    }
  }
}

[data-type="checkbox"] {
  >input {
    &[type="checkbox"] {
      +.text {
        padding-left: calc(#{$checkbox-size} + 10px);
        &::before {
          width: $checkbox-size;
          height: $checkbox-size;
          min-width: $checkbox-size;
          border: 1px solid $checkbox-border-color;
          @include border-radius($checkbox-radius);
        }
      }
      &:checked {
        +.text {
          &::after {
            content: "";
            top: 3px;
            left: 9px;
            width: 10px;
            height: 20px;
            position: absolute;
            border-right: 4px solid;
            border-bottom: 4px solid;
            border-color: $checkbox-check-color;
            @include rotate(45);
          }
        }
      }
    }
  }
  &.--check-list {
    >input {
      &[type="radio"],
      &[type="checkbox"] {
        &:checked {
          +.text {
            &::after {
              top: 1px;
            }
          }
        }
      }
    }
  }
  &.--no-label {
    margin: 0;
    >input {
      &[type="checkbox"] {
        +.text {
          padding-left: 0;
          top: 0;
          &::before {
            position: static;
            width: $main-input-height;
            height: $main-input-height;
          }
          &::after {
            top: 1px;
            left: 13px;
            width: 15px;
            height: 30px;
            border-right: 5px solid;
            border-bottom: 5px solid;
            border-color: #3587c0;
          }
        }
      }
    }
  }
  &.--table {
    height: auto;
    min-height: 0;
    >input {
      &[type="checkbox"] {
        +.text {
          &::before {
            top: -18px;
          }
          &::after {
            top: -16px;
          }
        }
      }
    }
  }
}
